/***************************************************************************
                          Lifetime_slots.cpp  -  description
                             -------------------
    begin                : Son Apr 6 2003
    copyright            : (C) 2003 by ChrM
    email                : chrm@chrm.info
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gleitzeit.h"
#include "minibutton.h"

#include <qlabel.h>
#include <qlineedit.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolor.h>
#include <qcheckbox.h>
#include <qradiobutton.h>


// TODO: config file im $HOME speichern als .-File!
// QString QDir::homeDirPath () [static]
#define CONFIG_FILE ".lifetime.conf"

/** No descriptions */
void Lifetime::button_clicked(){
  if(this->running) {
    this->running = false;
    this->the_timer->stop();
    this->LineEdit2->setEnabled(true);
    this->updateConfig(0);
    this->goTime = this->timer->getCurrentTimeAsString();
    this->workMinutesToday = (int)(this->timer->getWorkTime());
    this->writeDayToFile();
    PushButton1->setText( "Kommt" );
    PushButton1->setIconSet(this->kommtIcon);
    
  }
  else {
    this->running = true;    
    this->timer->reset(LineEdit2->text());
    this->LineEdit2->setEnabled(false);
    this->ProgressBar1->setProgress(0);
    this->comeTime = this->timer->getCurrentTimeAsString();
    this->workTime = (LineEdit2->text());
    this->updateConfig(1);
    this->the_timer->start(this->interval);
    PushButton1->setText( "Geht" );
    PushButton1->setIconSet(this->gehtIcon);
    
  }
}

/** No descriptions */
void Lifetime::timer_signal(){
  if(this->running) {
    LineEdit1->setText(this->timer->getCurrentTimeAsString());
    ProgressBar1->setProgress( this->timer->getProgress() );

    double overtime = this->timer->getOvertime();
        
    TextLabel1->setText( this->timer->getForamtedTime(overtime) +\
                         " [seit " + this->comeTime + "]" );
                          
    if(this->timer->getProgress() < 100) {
      TextLabel1->setPalette( QPalette( QColor(255, 0, 0) ) );
      this->mb->setPalette( QPalette( QColor(255, 0, 0) ) );
      this->setCaption( "Lifetime" );
    }
    else {
      TextLabel1->setPalette( QPalette( QColor(0, 224, 56) ) );
      this->setCaption( "Lifetime - GEH' HEIM!" );
      this->mb->setPalette( QPalette( QColor(0, 224, 56) ) );
    }

    if((int)(this->timer->getWorkTime()) > (int)(this->autoStopTime.toFloat() * 60)) {
      this->running = false;
      this->the_timer->stop();
      this->LineEdit2->setEnabled(true);
      this->updateConfig(0);
      this->goTime = this->timer->getCurrentTimeAsString();
      this->workMinutesToday = (int)(this->timer->getWorkTime());
      this->writeDayToFile();
      PushButton1->setText( "Kommt" );
      PushButton1->setIconSet(this->kommtIcon);

      QMessageBox::information( this, "Auto-Stop wurde ausgelst!",
                                "Auf Grund der Zeitberschreitung wurde der Tag gespeichert.");
    }
  }
  else {
    TextLabel1->setText("Drcke \"Kommt\" um die Zeit zu starten!");  
  }
}

/** Updates the config file online */
bool Lifetime::updateConfig(int _type){
  FILE *stream;
  QString s1, s2;

  qDebug("Save Settings...");
  
  if( (stream  = fopen( (this->userHomePath + CONFIG_FILE).latin1(), "wt"  )) == NULL )
  {     
    QMessageBox::information( this, "lifetime.conf - nicht gefunden! " + (this->userHomePath + CONFIG_FILE),
                                "Config-File nicht gefunden! Big problem!");
                                
    qDebug("ERROR: Can't find config file: %s", (this->userHomePath + CONFIG_FILE).latin1());
    return false;  
  } else {           
    if(_type == 0)
      s1 = "closed";
    else
      s1 = "running";
      
    s2 = this->workTime + "\n" + s1 + "\n" + this->comeTime + "\n" + \
         this->autoStopTime + "\n" + this->workDesc + "\n" + this->outputFile + "\n" +
         this->csvDelimiter + "\n" + this->openCloseStatus + "\n" + this->miniPosition + "\n";
    fprintf (stream, s2.latin1());
  }

  if( fclose( stream ))
    return false;

  return true;  
}


/** Loads the config file */
bool Lifetime::loadConfigFile(){
  FILE *stream;

  if( (stream  = fopen( (this->userHomePath + CONFIG_FILE).latin1(), "rt"  )) == NULL )
  {
    if( (stream  = fopen( (this->userHomePath + CONFIG_FILE).latin1(), "wt"  )) == NULL )
      return false;
    else {
      QMessageBox::information( this, "lifetime.conf - nicht gefunden! ",
                                "Config-File nicht gefunden - es wird eins angelegt.\n" + (this->userHomePath + CONFIG_FILE));
      fprintf (stream, "7.5\nclosed\n08:00:00\n10.0\nSchwer gearbeitet...\ntimes.csv\n;\n01\n0\n");
      this->comeTime = "08:00:00";
      this->workTime = "7.5";
      this->appState = "closed";
      this->autoStopTime = "10.0";
      this->workDesc = "Schwer gearbeitet...";
      this->outputFile = "times.csv";
      this->csvDelimiter = ";";
      this->openCloseStatus = "01";
      this->miniPosition = "0";
    }
  }
  else {
    char tmpStr [255];
    fgets(tmpStr, 255, stream);
    this->workTime = tmpStr;
    this->workTime = this->workTime.remove(this->workTime.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->appState = tmpStr;
    this->appState = this->appState.remove(this->appState.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->comeTime = tmpStr;
    this->comeTime = this->comeTime.remove(this->comeTime.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->autoStopTime = tmpStr;
    this->autoStopTime = this->autoStopTime.remove(this->autoStopTime.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->workDesc = tmpStr;
    this->workDesc = this->workDesc.remove(this->workDesc.length()-1, 1);   
    fgets(tmpStr, 255, stream);
    this->outputFile = tmpStr;
    this->outputFile = this->outputFile.remove(this->outputFile.length()-1, 1);      
    fgets(tmpStr, 255, stream);
    this->csvDelimiter = tmpStr;
    this->csvDelimiter = this->csvDelimiter.remove(this->csvDelimiter.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->openCloseStatus = tmpStr;
    this->openCloseStatus = this->openCloseStatus.remove(this->openCloseStatus.length()-1, 1);
    fgets(tmpStr, 255, stream);
    this->miniPosition = tmpStr;
    this->miniPosition = this->miniPosition.remove(this->miniPosition.length()-1, 1);
  }

  if( fclose( stream ))
    return false;
      
  return true;
}
/** Writes the day statistic to file */
bool Lifetime::writeDayToFile(){
  QDate today = QDate::currentDate();
  FILE *stream;

  if( (stream  = fopen( this->outputFile.latin1(), "at"  )) == NULL )
  {
    return false;
  }
  else {
    QString appendThis = today.toString("dd.MM.yyyy (ddd)") + this->csvDelimiter + this->comeTime + this->csvDelimiter + this->goTime + \
                         this->csvDelimiter + this->timer->getForamtedTime(this->timer->getOvertime()) + \
                         this->csvDelimiter + this->workDesc + "\n";
    qDebug("-->" + appendThis);
    fprintf (stream, appendThis.latin1());
    if( fclose( stream ))
      return false;
    return true;
  }
}

/** Opens the Setting-Dialog and get Values */
void Lifetime::openSettings(){
  
  this->mySettings->LineEdit1->setText(this->workTime);
  this->mySettings->LineEdit2->setText(this->comeTime);
  this->mySettings->LineEdit3->setText(this->workDesc);
  this->mySettings->LineEdit16->setText(this->csvDelimiter);
  this->mySettings->LineEdit17->setText(this->outputFile);
  this->mySettings->LineEdit52->setText(this->autoStopTime);
  if(this->openCloseStatus.mid(0,1).toInt() == 1) this->mySettings->CheckBox1->setChecked(TRUE);
  else this->mySettings->CheckBox1->setChecked(FALSE);

  int onExit = this->openCloseStatus.mid(1,2).toInt();
  if(onExit == 0) this->mySettings->RadioButton13->setChecked(TRUE);
  else if(onExit == 1) this->mySettings->RadioButton14->setChecked(TRUE);
  else if(onExit == 2) this->mySettings->RadioButton15->setChecked(TRUE);
       
  this->mySettings->show();
  //if(!this->mySettings->myRetval) return;
    
  /*this->workTime = this->mySettings->LineEdit1->text();
  this->comeTime = this->mySettings->LineEdit2->text();
  this->workDesc = this->mySettings->LineEdit3->text();
  this->csvDelimiter = this->mySettings->LineEdit16->text();
  this->outputFile = this->mySettings->LineEdit17->text();
  this->autoStopTime = this->mySettings->LineEdit52->text();
  if(this->mySettings->CheckBox1->isChecked()) this->openCloseStatus = "1";
  else this->openCloseStatus = "0";

  if(this->mySettings->RadioButton13->isChecked()) this->openCloseStatus += "0";
  else if(this->mySettings->RadioButton14->isChecked()) this->openCloseStatus += "1";
  else if(this->mySettings->RadioButton15->isChecked()) this->openCloseStatus += "2";

  LineEdit2->setText(this->workTime);
  this->timer->reset(LineEdit2->text(), this->comeTime);
    
  if(this->running) {    
    this->updateConfig(1);    
  }
  else {    
    this->updateConfig(0);    
  } */
}

/** Saves the Settings */
bool Lifetime::saveSettings(){
  this->workTime = this->mySettings->LineEdit1->text();
  this->comeTime = this->mySettings->LineEdit2->text();
  this->workDesc = this->mySettings->LineEdit3->text();
  this->csvDelimiter = this->mySettings->LineEdit16->text();
  this->outputFile = this->mySettings->LineEdit17->text();
  this->autoStopTime = this->mySettings->LineEdit52->text();
  if(this->mySettings->CheckBox1->isChecked()) this->openCloseStatus = "1";
  else this->openCloseStatus = "0";

  if(this->mySettings->RadioButton13->isChecked()) this->openCloseStatus += "0";
  else if(this->mySettings->RadioButton14->isChecked()) this->openCloseStatus += "1";
  else if(this->mySettings->RadioButton15->isChecked()) this->openCloseStatus += "2";

  LineEdit2->setText(this->workTime);
  this->timer->reset(LineEdit2->text(), this->comeTime);

  if(this->running) {
    return this->updateConfig(1);
  }
  else {
    return this->updateConfig(0);
  }
}

/** Minimize to little button */
void Lifetime::minimizeMe(){
  this->hide();
  qDebug("Switch to miniMode...");
  this->mb->show();
  //qDebug("Switch to normalMode...");
  //this->show();
}

/** Shows a StatTable object */
void Lifetime::showTable(){
  this->myTable->fileName = this->outputFile;
  this->myTable->delim = this->csvDelimiter;
  if(this->myTable->readData())
    this->myTable->show();
  else
    QMessageBox::information( this, "Protokolldatei nicht gefunden!",
                                "Du musst zuerst eine 'Kommt/Geht'-Sequenz aufzeichnen.");
}

/** Shows the 'About' dialog */
void Lifetime::showAbout(){     
  QMessageBox::information( this, "ber Lifetime",
                                "Lifetime 0.7\n(c) 2004 by ChrM\nhttp://chrm.info");   
}
