/***************************************************************************
                          minibutton.cpp  -  description
                             -------------------
    begin                : Mon Apr 14 2003
    copyright            : (C) 2003 by ChrM
    email                : chrm@chrm.info
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "minibutton.h"
#include <qapplication.h>

MiniButton::MiniButton(QWidget* _parent,  const char* name, bool modal, int _size, WFlags fl, int _pos)
  : QDialog( _parent, name, modal, fl )
{
  this->setCaption( tr( "Lifetime Mini" ) );
  this->mySize = _size;
  this->myPos = _pos;
  this->parent = _parent;
  this->setGeometry(0, 0, this->mySize, this->mySize);

  this->setPositionOnScreen();
  this->setPalette( QPalette( QColor(255, 0, 0) ) );

  this->theButton = new QPushButton(this, "mButton");
  this->theButton->setGeometry(0, 0, this->mySize, this->mySize);
  QToolTip::add(  this->theButton, tr( QString::fromUtf8( "Lifetime" ) ) );
  //theButton->setText("x");
  
  connect(theButton, SIGNAL(clicked()), this, SLOT(button_clicked()));
}

MiniButton::~MiniButton(){
}

/** No descriptions */
void MiniButton::button_clicked(){
  this->parent->show();
  this->hide();  
}

/** Sets properties of the Minibutton */
bool MiniButton::setProps(int _size, int _pos){
  this->mySize = _size;
  this->myPos = _pos;
  this->setPositionOnScreen();
  return true;
}

/** Sets the position */
void MiniButton::setPositionOnScreen(){  
  QRect r = QApplication::desktop()->rect();
  
  if(this->myPos == 0)
    this->move( r.width() - this->mySize, r.height()- this->mySize - 30);
  else if(this->myPos == 1)
    this->move( 0, r.height()- this->mySize - 30);
  else if(this->myPos == 2)
    this->move( r.width() - this->mySize, 0 );
  else
    this->move( 0, 0 );      
}


#include "minibutton.moc"

