/***************************************************************************
                          mytimer.cpp  -  description
                             -------------------
    begin                : Don Apr 3 2003
    copyright            : (C) 2003 by ChrM
    email                : chrm@chrm.info
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "mytimer.h"

myTimer::myTimer(QString _timeToWork){
  // Calculate current Time
  /*time( &this->ltime );
  this->myTime = localtime(&ltime); */
  this->myTime = QTime::currentTime();
  this->timeToWork = (_timeToWork.toFloat() * 60); 
}

myTimer::~myTimer(){
}

/** Resets the "come"-time */
bool myTimer::reset(QString _timeToWork){
  this->myTime = QTime::currentTime();
  this->timeToWork = (_timeToWork.toFloat() * 60);
  return true;
}

bool myTimer::reset(QString _timeToWork, QString _currentTimeReplace){
  //this->myTime = QTime::currentTime();
  //this->myTime = QTime::fromString(_currentTimeReplace);
  int h, m, s, dp;
  
  dp = _currentTimeReplace.find(':');
  h = _currentTimeReplace.mid(0, dp).toInt();
  m = _currentTimeReplace.mid(dp + 1, 2).toInt();
  s = _currentTimeReplace.right(2).toInt();
    
  QTime lastStartTime = QTime(h, m, s);
  this->myTime = lastStartTime;
  
  this->timeToWork = (_timeToWork.toFloat() * 60);
  return true;
}

/** Calculates the "work" time. After this call getWorkTime() */
double myTimer::getOvertime(){
  return (this->getWorkTime() - this->timeToWork);
}

/** Gets the current "work" time in minutes */
double myTimer::getWorkTime(){
  // get current time:
  /*time_t tmp_ltime
  time( &tmp_ltime );
  struct tm *tmp_myTime;
  tmp_myTime = localtime(&tmp_time);*/
  QTime tmpTime = QTime::currentTime();

  // Calc differnce
  return ((double)this->myTime.secsTo(tmpTime) / 60);
}

/** Gets the progress in % */
int myTimer::getProgress(){
  return (int)(this->getWorkTime() / this->timeToWork * 100);  
}

/** Sets the time, you must work every day */
void myTimer::setTimeToWork(QString _timeToWork){
  this->timeToWork = (_timeToWork.toFloat() * 60); 
}

/** Calculates minutes from QString like 7.5 -> 450 */
double myTimer::calcMinutes(QString _time){
  double retVal;
  retVal = (_time.toFloat() * 60);
  return retVal;
}
/** No descriptions */
QString myTimer::getCurrentTimeAsString(){
  QTime tmpTime = QTime::currentTime();
  return tmpTime.toString();  
}
/** Gets the minutes as 1:25 h */
QString myTimer::getForamtedTime(double _minutes){
  int std = ((int)(_minutes/60));
  int min = abs((int)(_minutes - std * 60));
  QString minutes;
  if(min < 10)
    minutes = "0" + QString::number(min);
  else
    minutes = QString::number(min);
    
  if(_minutes <= 0)
    return ("-" + QString::number(abs(std)) + ":" + minutes);
  else
    return ("+" + QString::number(std) + ":" + minutes);
}

/** Adds two times in the form: "-2:33 + (+1:59)" to "-0:34"  */
QString myTimer::addOverTimes(QString _t1, QString _t2){

  int h1, h2, m1, m2, dp, sig1=1, sig2=1;
  int h, m;
  QString hS, mS, retVal;
  
  //_t1 = _t1.stripWhiteSpace();
  //_t2 = _t2.stripWhiteSpace();

  _t1 = _t1.replace(" ", "");
  _t2 = _t2.replace(" ", "");

  //qDebug("t1/t2 "+_t1+_t2); 
  
  dp = _t1.find(':');
  h1 = _t1.mid(0, dp).toInt();
  m1 = _t1.mid(dp + 1, 2).toInt();

  //qDebug("dp: %d, h1: %d, m1: %d", dp,h1,m1); 
  
  dp = _t2.find(':');
  h2 = _t2.mid(0, dp).toInt();
  m2 = _t2.mid(dp + 1, 2).toInt();

  //qDebug("dp: %d, h2: %d, m2: %d", dp,h2,m2);

  if(_t1.mid(0,1) == "-") sig1 = -1;
  if(_t2.mid(0,1) == "-") sig2 = -1;
    
  m1 = sig1 * (abs(h1) * 60 + abs(m1));
  m2 = sig2 * (abs(h2) * 60 + abs(m2));

  h = (int)((m1 + m2) / 60);
  m = ((m1 + m2) % 60);
  
  //qDebug("h: %d, m: %d (m1+m2): %d",h,m,m1+m2);

  if(abs(m) < 10)
    mS =  "0" + QString::number(abs(m));
  else
    mS =  QString::number(abs(m));
  

  hS = QString::number(abs(h));
      
  if((m1 + m2) < 0) {    
    return ("-" + hS + ":" + mS);
  }
    
  return (hS + ":" + mS);
}
