/***************************************************************************
                          mytimer.h  -  description
                             -------------------
    begin                : Don Apr 3 2003
    copyright            : (C) 2003 by ChrM
    email                : chrm@chrm.info
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYTIMER_H
#define MYTIMER_H

#include <time.h>
#include <qstring.h>
#include <qdatetime.h>
#include <math.h>
#include <stdlib.h>

/**Managed all time claculations
  *@author ChrM
  */

class myTimer {
public: 
	myTimer(QString _timeToWork);
  /** gets the overtime as + or - value  */
  double getOvertime();
  /** Resets the "come"-time */
  bool reset(QString _timeToWork);
  bool reset(QString _timeToWork, QString _currentTimeReplace);
	~myTimer();
  /** Sets the time, you must work every day */
  void setTimeToWork(QString);
  /** Gets the progress in % */
  int getProgress();
  /** Gets the "work" time in minutes */
  double getWorkTime();
  /** Calculates minutes from QString like 7.5 -> 450 */
  double calcMinutes(QString);
  /** No descriptions */
  QString getCurrentTimeAsString();
  /** Gets the minutes as 1:25 h */
  QString getForamtedTime(double _minutes);
  /** Adds two time in the form: "-2:33 + (+1:59)" to "-0:34"  */
  static QString addOverTimes(QString _t1, QString _t2);

private:
  // Variables
  /*time_t ltime;
  struct tm *myTime;*/

  double timeToWork;       // in minutes
  QTime myTime;
  double currentWorkTime;  // in minutes
  
};

#endif
